% 05/05/2012
% Random generation of the neural network weights, with
% uniform distribution in the interval [-0.1,+0.1]
% function [w1,w2,eq,eqv,stw1,stw2,rms_w,eqv_min,eqmv_min,niter_v,niter,nitermax] = init(n_in,n_hid,n_out);
% n_in = number of inputs
% n_hid = number of neurons at the hidden layer
% n_out = number of neurons at the output layer
% w1, w2: Matrices of weights (one for each layer)
% w1: n_hid x (n_in+1)   w2: n_out x (n_hid+1)
% Type of weight generation:
% Option 1 -> Start the training from a random initial condition
% Option 2 -> Restart the training from the same initial condition
% Option 3 -> Restart the training from the last set of weights obtained
%             after training
%
function [w1,w2,eq,eqv,stw1,stw2,rms_w,eqv_min,eqmv_min,niter_v,niter,nitermax] = init(n_in,n_hid,n_out)
disp('(1) Generate w10 and w20, and save');
disp('(2) Copy existing w10 and w20');
disp('(3) Copy existing w1 and w2');
resp = input('Type of weight generation: ');
if resp == 1;
	w1 = -0.1 + 0.2*rand(n_hid,n_in+1);
	w2 = -0.1 + 0.2*rand(n_out,n_hid+1);
	save w10 w1;save w20 w2;
	eq = [];eqv = [];stw1 = [];stw2 = [];rms_w = [];eqv_min = [];eqmv_min = [];niter_v = 0;niter = 1;
    nitermax = input('Maximum number of iterations = ');
elseif resp == 2,
	load w10;load w20;
	eq = [];eqv = [];stw1 = [];stw2 = [];rms_w = [];eqv_min = [];eqmv_min = [];niter_v = 0;niter = 1;
    nitermax = input('Maximum number of iterations = ');
elseif resp == 3,
	load w1;load w2;
	load evol;
    niterad = input('Additional number of iterations = ');
    nitermax = niter+niterad;
else
	error('Not a valid option!');
end
